#include "../server/server.h"

summary_list *get_old_summary(bb_rid room);

main(int argc, char *argv[])
{
    directory_entry room_info;
    bb_rid room;
    summary_list *summary;

    setlinebuf(stdout);
    setlinebuf(stderr);
    chdir(MESSAGEBASE);
    if (!database_init(FALSE)) {
	perror("database init failed");
	return 1;
    }
    for (room = 0; room <= Last_rid; room++) {
	if (!get_directory_entry(&room_info, room))
	    continue;
	printf("%d %s. . . ", room, room_info.name);
	fflush(stdout);
	if (!(summary = get_old_summary(room))) {
	    fprintf(stderr, "\nError retrieving summary for %s (%d)\n",
		    room_info.name, room);
	    continue;
	}
	printf(" %d. . . ", summary->count);
	fflush(stdout);
	if ((summary->count <= 0 &&
	     room_info.first_message_number <
	     room_info.final_message_number) ||
	    (summary->count > 0 &&
	     (summary->list[0].number < room_info.first_message_number ||
	      summary->list[summary->count - 1].number >=
	      room_info.next_message_number))) {
	    fprintf(stderr,
		    "\nwarning: %s (%d): summary doesn't match room info\n",
		    room_info.name, room);
	}
	if (!put_summary(room)) {
	    fprintf(stderr, "\nError storing summary for %s (%d)\n",
		    room_info.name, room);
	    continue;
	}
	printf(" copied.\n");
	dump_cache();
    }
    database_shutdown();
    return 0;
}
