#include <ndbm.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>

#include "../server/server.h"

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

main(argc,argv)
     int argc;
     char *argv[];
{
  char selector[40];
  if(!database_init()) {
    printf("Error opening databases.\n");
    exit(0);
  }

  while(!feof(stdin)) {
    gets(selector);
    if(strcmp(selector,"directory_entry")==0) {
      char room[ROOM_SIZE];
      directory_entry directory_info;
      int bogus;

      bzero(room,sizeof(room));
      bzero(&directory_info,sizeof(directory_info));
      gets(room);
      gets(directory_info.owner);
      scanf("%d\n%d\n%d\n%d\n",
	    &directory_info.creation_time,
	    &directory_info.default_expiration,
	    &bogus,
	    &directory_info.next_message_number);
      directory_info.default_class = bogus;
      gets(directory_info.summary_line);
      scanf("%d\n%d\n",
	    &directory_info.final_message_number,
	    &directory_info.first_message_number);
      put_directory_entry(room,&directory_info);
      printf("directory_entry %s (%d)\n",room,directory_info.default_class);
    } else if(strcmp(selector,"message_entry")==0) {
      char room[ROOM_SIZE];
      int message;
      message_entry message_info;

      bzero(room,sizeof(room));
      bzero(&message_info,sizeof(message_info));
      gets(room);
      scanf("%d\n%d\n%d\n%d\n",
	    &message,
	    &message_info.date,
	    &message_info.size,
	    &message_info.deleted);
      gets(message_info.poster);
      gets(message_info.subject);
      scanf("%d\n",&message_info.expiration);
      put_message_entry(room,message,&message_info);
      printf("message_entry ('%s',%d)\n",room,message);
    } else if(strcmp(selector,"user_entry")==0) {
      char id[ID_SIZE+100];
      user_entry user_info;

      bzero(id,sizeof(id));
      bzero(&user_info,sizeof(user_info));
      gets(id);
      id[ID_SIZE-1] = (char) 0;
      scanf("%d\n",
	    &user_info.last_access_time);
      gets(user_info.passwd);
      gets(user_info.nick);
      gets(user_info.default_room);
      gets(user_info.last_access_source);
      scanf("%d\n%d\n%d\n",
	    &user_info.uses,
	    &user_info.posts,
	    &user_info.connect_time);
      put_user_entry(id,&user_info);
      printf("user_entry %s\n",id);
    } else if(strcmp(selector,"room_entry")==0) {
      char room[ROOM_SIZE];
      char id[ID_SIZE+100];
      room_user_entry room_user_info;
      int bogus, bogus2;

      bzero(room,sizeof(room));
      bzero(id,sizeof(id));
      bzero(&room_user_info,sizeof(room_user_info));
      gets(room);
      gets(id);
      id[ID_SIZE-1] = (char) 0;
      scanf("%d\n%d\n%d\n",
	    &room_user_info.last_message_read,
	    &bogus2,
	    &bogus);
      room_user_info.hidden = bogus2;
      room_user_info.class = bogus;
      put_room_user_entry(room,id,&room_user_info);
      printf("room_user_entry ('%s','%s')\n",room,id);
    } else {
      printf("----unrecognized selector %s\n",selector);
    }
  }
  database_shutdown();
}
