#include <ndbm.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>

#include "../server/server.h"

typedef struct {
  char type;
  char room[ROOM_SIZE];
  long message;
} room_message;

typedef struct {
  char type;
  char room[ROOM_SIZE];
  char id[ID_SIZE];
} room_id_t;

main(argc,argv)
     int argc;
     char *argv[];
{
  datum key, content;
  DBM *dbm;
  char id[ID_SIZE];

  argc--; argv++;
  if(!argc) exit(0);
  for(;argc;argc--,argv++) {
    dbm = dbm_open(*argv,O_RDONLY,0);
    if(dbm == NULL) {
      continue;
    }
    for (key = dbm_firstkey(dbm);
	 key.dptr != NULL;
	 key = dbm_nextkey(dbm)) {
      content = dbm_fetch(dbm,key);
      if(content.dsize == sizeof(directory_entry)) {
	printf("directory_entry\n%s\n%s\n%d\n%d\n%d\n%d\n%s\n%d\n%d\n",
	       key.dptr,
	       ((directory_entry *) content.dptr)->owner,
	       ((directory_entry *) content.dptr)->creation_time,
	       ((directory_entry *) content.dptr)->default_expiration,
	       ((directory_entry *) content.dptr)->default_class,
	       ((directory_entry *) content.dptr)->next_message_number,
	       ((directory_entry *) content.dptr)->summary_line,
	       ((directory_entry *) content.dptr)->final_message_number,
	       ((directory_entry *) content.dptr)->first_message_number);
      } else if(content.dsize == sizeof(message_entry)) {
	printf("message_entry\n%s\n%d\n%d\n%d\n%d\n%s\n%s\n",
	       ((room_message *) key.dptr)->room,
	       ((room_message *) key.dptr)->message,
	       ((message_entry *) content.dptr)->date,
	       ((message_entry *) content.dptr)->size,
	       ((message_entry *) content.dptr)->deleted,
	       ((message_entry *) content.dptr)->poster,
	       ((message_entry *) content.dptr)->subject,
	       ((message_entry *) content.dptr)->expiration);
      } else if(content.dsize == sizeof(user_entry)) {
	bzero(id,sizeof(id));
	bcopy(key.dptr,id,key.dsize);
	printf("user_entry\n%s\n%d\n%s\n%s\n%s\n%s\n%d\n%d\n%d\n",
	       id,
	       ((user_entry *) content.dptr)->last_access_time,
	       ((user_entry *) content.dptr)->passwd,
	       ((user_entry *) content.dptr)->nick,
	       ((user_entry *) content.dptr)->default_room,
	       ((user_entry *) content.dptr)->last_access_source,
	       ((user_entry *) content.dptr)->uses,
	       ((user_entry *) content.dptr)->posts,
	       ((user_entry *) content.dptr)->reads);
      } else if(content.dsize == sizeof(room_user_entry)) {
	printf("room_entry\n%s\n%s\n%d\n%d\n%d\n",
	       ((room_id_t *) key.dptr)->room,
	       ((room_id_t *) key.dptr)->id,
	       ((room_user_entry *) content.dptr)->last_message_read,
	       ((room_user_entry *) content.dptr)->hidden,
	       ((room_user_entry *) content.dptr)->class);
      } else {
	fwrite(key.dptr,key.dsize,1,stdout);
	printf("\n\t");
	fwrite(content.dptr,content.dsize,1,stdout);
	printf("\n\n");
      }
    }
    dbm_close(dbm);
  }
}
