#include "../server/config.h"
#include "../server/server.h"
#include <ndbm.h>
#include <setjmp.h>
#include <sys/time.h>

struct timeval delta_time(struct timeval t1, struct timeval t2);

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

char *classes[] =
  {"no_access","read_only","read_write","moderator","no_class"};

bb_rid room;
jmp_buf Main_loop_env;
time_t Now;
bb_uid Owner_uid;
boolean Server_Shutdown = 0;
boolean Server_Reboot = 1;
int master_socket;
int Current_client = 0;
char **Argv;
int free_slot = 0;

signal_t sigsegv()
{
  fprintf(stderr, "Died on %d\n", room++);
  signal(SIGSEGV, sigsegv);
  longjmp(Main_loop_env, 0);
  return (signal_t) 0;
}

main(int argc, char *argv[])
{
  directory_info *dir_info;
#ifdef PRINT_RESULTS
  char id_string[40];
#endif /* PRINT_RESULTS */
  struct timeval t1, t2, delta;

  setlinebuf(stdout);
  setlinebuf(stderr);
  signal(SIGSEGV, sigsegv);
  chdir(MESSAGEBASE);
  database_init();
  if((client[0].uid = get_uid(argv[1])) == -1) {
    printf("no such user %s\n", argv[1]);
    return 1;
  }
  client[0].dir_info = (directory_info **)
    malloc((Last_rid+1) * sizeof(directory_info *));
  gettimeofday(&t1, 0);
  for (room=0; room <= Last_rid; room++) {
    setjmp(Main_loop_env);
    if(!(dir_info = get_dir_info(0, room))) continue;
    if(!NO_ACCESS(dir_info->class) && dir_info->priority > SYSTEM_CUTOFF) {
    }
  }
  gettimeofday(&t2, 0);
  delta = delta_time(t1, t2);
  printf("%3d%07.3f\n", delta.tv_sec, delta.tv_usec/1000.0);
  gettimeofday(&t1, 0);
  for (room=0; room <= Last_rid; room++) {
    setjmp(Main_loop_env);
    if(!(dir_info = get_dir_info(0, room))) continue;
    if(!NO_ACCESS(dir_info->class) && dir_info->priority > SYSTEM_CUTOFF) {
    }
  }
  gettimeofday(&t2, 0);
  delta = delta_time(t1, t2);
  printf("%3d%07.3f\n", delta.tv_sec, delta.tv_usec/1000.0);
  database_shutdown();
}

struct timeval delta_time(struct timeval t1, struct timeval t2)
{
  struct timeval delta;

  delta.tv_sec = t2.tv_sec - t1.tv_sec;
  delta.tv_usec = t2.tv_usec - t1.tv_usec;
  if(delta.tv_usec < 0) {
    delta.tv_usec += 1000000;
    delta.tv_sec -= 1;
  }
  return delta;
}
