#ifndef DEBUG
#define DEBUG
#endif /* DEBUG */
#include "../server/config.h"
#include "../server/server.h"
#include <ndbm.h>
#include <stdio.h>
#include <sys/time.h>

struct timeval delta_time(struct timeval t1, struct timeval t2);

int max_active_slot;
struct client_struct client[MAX_CLIENTS];
boolean Read_only = FALSE;
time_t Now = 0;

char *message_summary(int number, message_entry *entry, boolean full,
		      int width);

main(argc, argv)
     int argc;
     char *argv[];
{
  int message;
  message_entry *message_info;
  char room[ROOM_SIZE];
  bb_rid rid;
  summary_list *summary;
  summary_entry *entry;
  struct timeval t1, t2, delta;

  chdir(MESSAGEBASE);
  openlog("timing", LOG_PID, LOG_LOCAL2);
  database_init();
  bzero(room, sizeof(room));
  strcpy(room, argv[1]);
  rid = get_rid(room);
  setlinebuf(stdout);
  gettimeofday(&t1, 0);
  summary = get_summary(rid);
  printf("put_summary: %d\n", put_summary(rid));
  gettimeofday(&t2, 0);
  delta = delta_time(t1, t2);
  printf("%3d%07.3f\n", delta.tv_sec, delta.tv_usec/1000.0);
  gettimeofday(&t1, 0);
  summary = get_summary(rid);
  for(entry = summary->list;
      entry < summary->list + summary->count;
      entry++) {
    message = entry->number;
    message_info = &(entry->header);
  }
  gettimeofday(&t2, 0);
  delta = delta_time(t1, t2);
  printf("%3d%07.3f\n", delta.tv_sec, delta.tv_usec/1000.0);
  database_shutdown();
}

struct timeval delta_time(struct timeval t1, struct timeval t2)
{
  struct timeval delta;

  delta.tv_sec = t2.tv_sec - t1.tv_sec;
  delta.tv_usec = t2.tv_usec - t1.tv_usec;
  if(delta.tv_usec < 0) {
    delta.tv_usec += 1000000;
    delta.tv_sec -= 1;
  }
  return delta;
}
