#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/server/group_changeclass.c 178 2004-05-05 06:09:03Z kc $")

#include "server.h"

static char *classes[] =
{"no_access", "read_only", "read_write", "moderator", "no_class"};

void server_groupchangeclass(int i)
{
  char id[ID_SIZE];
  char group[GROUP_SIZE];
  class_t class;
  DbUser db_user;
  group_info *groupinfo;
  bb_uid uid;
  bb_gid gid;
  FILE *log;

  read_socket_s(Client[i].socket, group, sizeof(group));
  read_socket_s(Client[i].socket, id, sizeof(id));
  read_socket_int(Client[i].socket, (int *) &class);
  
  if((gid = get_gid(group))==-1)
    SERVER_ERROR("no such group");
  if((uid = get_uid(id))==-1)
    SERVER_ERROR("no such user");
  if(!(groupinfo = get_group_info(i, gid)))
    SERVER_ERROR("error accessing group/user information");
  if(!MODERATOR_ACCESS(groupinfo->class) && !Client[i].owner)
    SERVER_ERROR("permission denied");
  if(!get_db_user(&db_user, uid))
    SERVER_ERROR("error accessing user information");
  db_user.group_class[gid] = class;
  if(!put_db_user(uid, &db_user))
    SERVER_ERROR("error storing user information");
  update_cached_user_group_info(uid, gid);
  write_socket_code(Client[i].socket, SERVER_ACK);

#ifdef CHANGECLASSLOGFILE
  if ((log = fopen(CHANGECLASSLOGFILE, "a"))) {
    time_t t;

    t = time(NULL);
    fprintf(log, "%s changeclassed %s to %s in group %s, %s",
	    Client[i].id, id, classes[class], group, ctime(&t));
    fflush(log);
  } else {
    time_t t;
    t = time(NULL);
    syslog(LOG_ERR, "changeclass.log: %m");
    syslog(LOG_ERR, "%s changeclassed %s in group %s to class %s, %s",
	   Client[i].id, id, group, classes[class], ctime(&t));
  }
#endif
}
