#include "server.h"

void server_groupchange(int i)
{
    char group[GROUP_SIZE];
    char new_owner[ID_SIZE];
    bb_gid gid;
    bb_uid new_owner_uid;
    group_entry group_info, new;

    read_socket_s(client[i].socket, group, sizeof(group));
    read_socket_s(client[i].socket, new.name, sizeof(new.name));
    read_socket_s(client[i].socket, new_owner, sizeof(new_owner));
    read_socket_int(client[i].socket, (int *)&new.default_class);
    read_socket_int(client[i].socket, (int *)&new.group_offset);
    read_socket_int(client[i].socket, (int *)&new.max_expiration);
    if ((gid = get_gid(group)) == -1)
	SERVER_ERROR("no such group");
    if (!get_group_entry(&group_info, gid))
	SERVER_ERROR("error accessing group information");
    if (client[i].uid != group_info.owner && !client[i].owner)
	SERVER_ERROR("permission denied");

    if (*new.name) {
	if (get_gid(new.name) != -1)
	    SERVER_ERROR("group already exists");
	put_gid(gid, new.name);
	remove_gid(group);
	strcpy(group_info.name, new.name);
    }
    if (*new_owner) {
	if ((new_owner_uid = get_uid(new_owner)) == -1)
	    SERVER_ERROR("no such user");
	group_info.owner = new_owner_uid;
    }
    if (new.default_class != -1)
	group_info.default_class = new.default_class;

    if (new.group_offset) {
	priority deltapriority;
	int j;

	if (!client[i].owner)
	    SERVER_ERROR("permission denied:  not owner");
	directory_stamp++;
	if (new.group_offset > 0)
	    new.group_offset--;
    /* x=0 means "don't change", so x>0 means x-1, while x<0 still means x */
	deltapriority = new.group_offset - group_info.group_offset;
	group_info.group_offset = new.group_offset;
	for (j = 0; j <= max_active_slot; j++)
	    if (client[j].signed_on)
		client[j].group_priority[gid] += deltapriority;
    }
    if (new.max_expiration != -1) {
	if (!client[i].owner)
	    SERVER_ERROR("permission denied:  not owner");
	group_info.max_expiration = new.max_expiration;
    }
    if (!put_group_entry(gid, &group_info))
	SERVER_ERROR("error storing group information");

    write_socket_code(client[i].socket, SERVER_ACK);
}
