#include "server.h"

void server_groupcreate(int i)
{
  char group[GROUP_SIZE];
  bb_gid gid;
  group_entry group_info;
  user_entry user_info;
  int j;

  read_socket_s(client[i].socket, group, sizeof(group));
  if(get_gid(group)!=-1)
    SERVER_ERROR("group already exists");
  if(!client[i].owner)
    SERVER_ERROR("permission denied");
  gid = add_gid(group);
  strcpy(group_info.name, group);
  group_info.owner = client[i].uid;
  group_info.default_class = DEFAULT_GROUP_CLASS;
  group_info.group_offset = DEFAULT_GROUP_OFFSET;
  group_info.max_expiration = MAX_EXPIRATION;
  if(!put_group_entry(gid, &group_info))
    SERVER_ERROR("error storing group information");
  if(!get_user_entry(&user_info, client[i].uid))
    SERVER_ERROR("error accessing user information");
  user_info.group_class[gid] = moderator;
  if(!(put_user_entry(client[i].uid, &user_info)))
    SERVER_ERROR("error storing user information");
  for(j=0; j <= max_active_slot; j++)
    if(client[j].signed_on && client[j].uid == client[i].uid)
      client[j].group_class[gid] = user_info.group_class[gid];
  write_socket_code(client[i].socket, SERVER_ACK);
}
