#include "server.h"

void server_grouppriority(int i)
{
    char group[GROUP_SIZE];
    priority priority;
    group_entry group_info;
    user_entry user_info;
    bb_gid gid;
    int j;

    read_socket_s(client[i].socket, group, sizeof(group));
    read_socket_int(client[i].socket, (int *)&priority);

    if ((gid = get_gid(group)) == -1)
	SERVER_ERROR("no such group");
    if (!get_group_entry(&group_info, gid))
	SERVER_ERROR("error accessing group information");
    if (!get_user_entry(&user_info, client[i].uid))
	SERVER_ERROR("error accessing user information");
    user_info.group_priority[gid] = priority - group_info.group_offset;
    if (!put_user_entry(client[i].uid, &user_info))
	SERVER_ERROR("error storing user information");
    update_cached_group_user_info(gid, client[i].uid);
    write_socket_code(client[i].socket, SERVER_ACK);
}
